package de.bsvrz.buv.plugin.bmvew;

/**
 * Diese Klasse reprsentiert die einzelnen Elemente eines Filters von Betriebsmeldungen. <br>
 * Implementiert das Interface {@link Cloneable}.
 * 
 * @version $Revision: 1.1 $ / $Date: 2010/02/02 15:14:30 $ / ($Author: HofmannJ $)
 * @author HofmannJ
 * 
 */
public class FilterElement implements Cloneable
{
  /**
   * Titel des Filterelements.
   */
  private String _filterElementTitel = null;

  /**
   * Regulrer Ausdruck, der den Filter ausmacht.
   */
  private String _filterElementRegEx = null;

  /**
   * Konstruktor, setzt den Titel des Filters sowie den regulren Ausdruck.
   * 
   * @param filterElementTitel
   *          Titel des Filters.
   * @param filterRegulaererAusdruck
   *          Regulrer Ausdruck des Filters.
   */
  public FilterElement(String filterElementTitel, String filterRegulaererAusdruck)
  {
    _filterElementTitel = filterElementTitel;
    _filterElementRegEx = filterRegulaererAusdruck;
  }

  /**
   * Liefert den Titel des Filters.
   * 
   * @return Titel des Filters.
   */
  public String getFilterElementTitel()
  {
    return _filterElementTitel;
  }

  /**
   * Setzt den Titel des Filters.
   * 
   * @param filterTitel
   *          Zu setzender Titel des Filters.
   */
  public void setFilterElementTitel(String filterTitel)
  {
    this._filterElementTitel = filterTitel;
  }

  /**
   * Liefert den regulren Ausdruck des Filters.
   * 
   * @return Regulrer Ausdruck des Filters.
   */
  public String getRegulaererAusdruck()
  {
    return _filterElementRegEx;
  }

  /**
   * Setzt den regulren Ausdruck des Filters.
   * 
   * @param regulaererAusdruck
   *          Zu setzender regulrer Ausdruck des Filters.
   */
  public void setRegulaererAusdruck(String regulaererAusdruck)
  {
    this._filterElementRegEx = regulaererAusdruck;
  }

  /**
   * Erzeugt einen Clone dieser Klasse.
   * 
   * @return Clone dieser Klasse.
   */
  public FilterElement clone()
  {    
    FilterElement betriebsMvFilterElement = new FilterElement(_filterElementTitel, _filterElementRegEx);
    return betriebsMvFilterElement;
  }

}
