package de.bsvrz.buv.plugin.bmvew;

import java.util.Iterator;
import java.util.List;

import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerDropAdapter;
import org.eclipse.swt.dnd.TransferData;

import de.bsvrz.sys.funclib.debug.Debug;

public class MeldungsanzeigeFallAdapter extends ViewerDropAdapter
{
  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  /**
   * Liste der SystemObjekte
   */
  private List<Meldung> _listeObjekte = null;

  /**
   * Verweis auf den TableViewer
   */
  @SuppressWarnings("unused")
	private TableViewer _tableViewer = null;

  /**
   * Ziel
   */
  private Object _ziel = null;

  /**
   * Syso Flag
   */
  private boolean _zielIstMeldung = true;

  private SpeicherTransfer _speicherTransfer;

  /**
   * Initialisierung des FallAdapters
   * 
   * @param viewer
   *          Viewer, auf den sich der Falladapter bezieht.
   * @param listeObjekte
   *          Liste der Systemobjekte, mit denen der Viewer gefttert wird.
   */
  protected MeldungsanzeigeFallAdapter(Viewer viewer, List<Meldung> listeObjekte)
  {
    super(viewer);
    this._listeObjekte = listeObjekte;

    if (viewer instanceof TableViewer)
    {
      this._tableViewer = (TableViewer)viewer;
    }

  }

  @Override
  public boolean performDrop(Object data)
  {


    if (data instanceof String)
    {
      String tempString = (String)data;

      // Prfen auf [PID] am Anfang des Strings:
      if (tempString.length() > 5)
      {
        String vergleich = tempString.substring(0, 5);

        if (vergleich.equals("[PID]"))
        {

          String tempPid = tempString.substring(5);


          _speicherTransfer = SpeicherTransfer.getInstanz();
          if (_speicherTransfer.getPid() != null && _ziel != null)
          {
            if (_speicherTransfer.getPid().equals(tempPid))
            {

              int neuePosition = positionObjektInListe(_ziel, _listeObjekte);

              _speicherTransfer.setNeuePosition(neuePosition);

              int altePosition = _speicherTransfer.getAltePosition();


              if ((neuePosition > -1) && (altePosition > -1))
              {
                _listeObjekte.remove(altePosition);

                if (neuePosition < altePosition)
                {
                  _listeObjekte.add(neuePosition, _speicherTransfer.getMeldung());
                }
                else if (neuePosition > altePosition)
                {
                  _listeObjekte.add(neuePosition--, _speicherTransfer.getMeldung());
                }
              }
              else if ((altePosition == -1) && (neuePosition > -1))
              {
                _listeObjekte.add(neuePosition, _speicherTransfer.getMeldung());
              }
              else if (neuePosition < 0)
              {
                _listeObjekte.add(_speicherTransfer.getMeldung());
              }
              else if (!_zielIstMeldung)
              {
                if (altePosition > -1)
                {
                  _listeObjekte.remove(altePosition);
                }
                _listeObjekte.add(_speicherTransfer.getMeldung());
              }
              else
              {
                _listeObjekte.add(_speicherTransfer.getMeldung());
              }

              // _listeObjekte.add(speicher.getSystemObject());
              _speicherTransfer.zuruecksetzenSpeicher();

              getViewer().setInput(_listeObjekte);
            }
            else
            {
              _debug.error(getClass().getName() + "::performDrop \n\t=> Die Pid des in "
                  + _speicherTransfer.getClass().getName() + "hinterlegten SystemObjekt(PID="
                  + _speicherTransfer.getPid() + ") entspricht nicht der Pid des zu droppenden SystemObjekts(PID="
                  + tempPid + "). Drop Abgebrochen.\n");
            }

          }
          else
          {
            _debug.error(getClass().getName() + "::performDrop \n\t=> In " + _speicherTransfer.getClass().getName()
                + " ist KEIN SystemObjekt hinterlegt. Drop Abgebrochen.\n");
          }

        }
        else
        {
          _debug.error(getClass().getName() + "::performDrop \n\t=> KEIN SYSTEMOBJEKT\n");
        }
      }

    }

    return false;
  }

  @Override
  public boolean validateDrop(Object target, int operation, TransferData transferType)
  {

    this._ziel = target;

    if (target instanceof Meldung)
    {
      // if(TextTransfer.getInstance().isSupportedType(transferType))
      // {
      // return true;
      // }
      // else
      // {
      // return false;
      // }
//      System.out.println("Meldung");
      _zielIstMeldung = true;
      return true;
    }
    else
    {
//      System.out.println("keine Meldung");
      _zielIstMeldung = false;
      return true;
    }

  }

  private int positionObjektInListe(Object object, List liste)
  {
    int i = -1;
    Iterator it = liste.iterator();
    while (it.hasNext())
    {
      i++;
//      System.out.println("I: " + i);
      if (it.next().equals(object))
      {
        break;
      }
    }

    if (i == -1)
    {
      _debug.error("-1");
    }

    return i;
  }

}
