package de.bsvrz.buv.plugin.engstvw;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.ui.IStartup;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.rw.rw.menu.ElementRegistrierung;
import de.bsvrz.buv.rw.rw.menu.deskriptoren.DeskriptorAktion;
import de.bsvrz.sys.funclib.debug.Debug;

/**
 * {@link IStartup} Implementierung, registriert alle Actions des Moduls Engstellenverwaltung zwecks Men- und
 * Symbolleistenaufbau bzw. deren Verwaltung.
 * 
 * @version $Revision: 1.2 $ / $Date: 2010/02/04 05:52:42 $ / ($Author: HofmannJ $)
 * 
 * @author HofmannJ
 * 
 */
public class Starter implements IStartup
{
  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  /**
   * In dieser Methode werden die von dem Modul Engstellenverwaltung bereitgestellten Actions generiert und in der
   * Klasse {@link ElementRegistrierung} ber deren Methode
   * {@link ElementRegistrierung#registriereDeskriptorAktion(de.bsvrz.buv.rw.rw.menu.deskriptoren.DeskriptorAktion)}
   * registriert.
   */
  public void earlyStartup()
  {
    IAction action = new Action() {
      public void run()
      {
        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
        IWorkbenchPage page = dw.getActivePage();

        try
        {
          page.showView("de.bsvrz.buv.plugin.engstvw.VerwaltungsSicht");
        }
        catch (PartInitException e)
        {
          e.printStackTrace();
        }
      }
    };
    action.setText("Engstellenverwaltung");
    action.setId("de.bsvrz.buv.plugin.engstvw.verwaltungsSicht");

    DeskriptorAktion deskriptorAktion = new DeskriptorAktion("de.bsvrz.buv.plugin.engstvw", action, false);

    try
    {
      ElementRegistrierung.getInstanz().registriereDeskriptorAktion(deskriptorAktion);
    }
    catch (IllegalArgumentException iae)
    {
      // Keine Registrierung mglich, keine weitere Ausgabe
    }

  }

}
