package de.bsvrz.buv.plugin.ereigniskal;

import de.bsvrz.buv.rw.basislib.ort.OrtsangabeEnumeratorAuswahl;
import de.bsvrz.dav.daf.main.config.SystemObject;

/**
 * Die Klasse {@link EintragRaeumlicheGueltigkeitNeu} reprsentiert die Datenstze zur rumlichen Gltigkeit, die im
 * Dialog {@link Definitionsdialog} in der Liste der rumlichen Gltigkeiten dargestellt werden. <br>
 * Implementiert das Interface {@link Cloneable}.
 * 
 * @version $Revision: 1.1 $ / $Date: 2010/02/02 15:21:42 $ / ($Author: HofmannJ $)
 * @author HofmannJ
 * 
 */
public class EintragRaeumlicheGueltigkeitNeu implements Cloneable
{
  /**
   * Enumerator, der die Art der Ortsangabe liefert.
   */
  private OrtsangabeEnumeratorAuswahl _ortsangabeEnumeratorAuswahl = null;

  /**
   * Name
   */
  private String _Name = null;

  /**
   * Info
   */
  private String _Info = null;

  /**
   * SystemObject
   */
  private SystemObject _SystemObjekt = null;

  /**
   * Konstruktor zur Erezugung eines Datensatzes der rumlichen Gltigkeit.
   * 
   * @param name
   *          Name der rumlichen Gltigkeit.
   * @param info
   *          Info zur rumlichen Gltigkeit.
   */
  public EintragRaeumlicheGueltigkeitNeu(String name, String info, SystemObject systemObjekt)
  {
    this._Name = name;
    this._Info = info;
    this._SystemObjekt = systemObjekt;
  }

  /**
   * Liefert den Namen der rumlichen Gltigkeit.
   * 
   * @return Name der rumlichen Gltigkeit.
   */
  public String getName()
  {
    return _Name;
  }

  /**
   * Setzt den Namen der rumlichen Gltigkeit.
   * 
   * @param name
   *          Name der rumlichen Gltigkeit.
   */
  public void setName(String name)
  {
    _Name = name;
  }

  /**
   * Liefert die Info zur rumlichen Gltigkeit.
   * 
   * @return Info zur rumlichen Gltigkeit.
   */
  public String getInfo()
  {
    return _Info;
  }

  /**
   * Setzt die Info zur rumlichen Gltigkeit.
   * 
   * @param info
   *          Info zur rumlichen Gltigkeit.
   */
  public void setInfo(String info)
  {
    _Info = info;
  }

  /**
   * Liefert einen Clone der Instanz dieser Klasse.
   * 
   * @return Clone der Instanz dieser Klasse.
   */
  public EintragRaeumlicheGueltigkeitNeu clone()
  {
    EintragRaeumlicheGueltigkeitNeu raeumlicheGueltigkeit = new EintragRaeumlicheGueltigkeitNeu(_Name, _Info,
        _SystemObjekt);
    return raeumlicheGueltigkeit;
  }

  public SystemObject getSystemObjekt()
  {
    return _SystemObjekt;
  }

  public void setSystemObjekt(SystemObject systemObjekt)
  {
    _SystemObjekt = systemObjekt;
  }

}
