package de.bsvrz.buv.plugin.ereigniskal;

import java.util.LinkedList;
import java.util.List;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Shell;

import de.bsvrz.dav.daf.main.ClientDavInterface;

/**
 * In diesem Dialog werden die aktuell definierten Ereigniskalender-Eintrge dargestellt. Fr jeden Eintrag wird der
 * Ereignis Name und der Zeitbereich (in Textdarstellung) dargestellt.
 * 
 * <br>
 * <br>
 * 
 * Die Klasse erfllt die technische Anforderungen des Segments Bedienung und Visualisierung (BUV): <br>
 * <ul>
 * <li>TAnf-Vi-BW-C3-6</li>
 * </ul>
 * 
 * @version $Revision: 1.1 $ / $Date: 2010/02/02 15:21:42 $ / ($Author: HofmannJ $)
 * @author HofmannJ
 * 
 */
public class Verwaltungsdialog extends Dialog
{
  /**
   * Verbindung zum DaV
   */
  private DaVKommunikation _daVKommunikation = null;

  /**
   * Definitionsdialog
   */
  private Definitionsdialog _definitionsdialog = null;

  /**
   * Liste aller Ereigniskalendereintrge.
   */
  private List<Eintrag> _ereigniskalenderEintraege = new LinkedList<Eintrag>();

  /**
   * Verbindung zum DaV.
   */
  private ClientDavInterface _connection = null;

  /**
   * Konstruktor fr neue Instanzen der Klasse {@link Verwaltungsdialog}.
   * 
   * @param parent
   *          Eltern-Shell, die fr die Darstellung benutzt werden soll.
   * @param connection
   *          Verbindung zum DaV.
   */
  public Verwaltungsdialog(Shell parent, ClientDavInterface connection)
  {
    super(parent);
  }

  /**
   * ffnet den Dialog {@link Verwaltungsdialog}.
   */
  public void oeffne()
  {

  }

  /**
   * Generiert die Elemente des Dialogs {@link Verwaltungsdialog}.
   * 
   */
  private void generiereGui()
  {
  }

  /**
   * Erzeugt einen neuen Eintrag und ffnet hierzu den Dialog {@link Definitionsdialog}.
   * 
   */
  private void aktionNeu()
  {

  }

  /**
   * ffnet den Dialog {@link Definitionsdialog} zur Bearbeitung des selektierten Eintrags.
   * 
   */
  private void aktionBearbeiten()
  {

  }

  /**
   * Kopiert den selektierten eintrag. Der Name des Eintrags wird um den Prfix "Kopie von" erweitert. Anschlieend
   * ffnet sich der Dialog {@link Definitionsdialog} zur Bearbeitung des kopierten Eintrags.
   * 
   */
  private void aktionKopieren()
  {

  }

  /**
   * Lscht den selektierten Eintrag. Der Benutzer muss hierzu einen Sicherheitsabfragedialog besttigen.
   * 
   */
  private void aktionLoeschen()
  {

  }

  /**
   * Zeigt die Hilfe zu diesem Dialog an.
   * 
   */
  private void aktionHilfe()
  {

  }

  /**
   * Schliet den Dialog {@link Verwaltungsdialog}.
   * 
   */
  private void aktionSchliessen()
  {

  }

}
