/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.plugin.pruefrw.druckvorschau;

import java.text.SimpleDateFormat;
import java.util.Date;

import net.sf.paperclips.DefaultGridLook;
import net.sf.paperclips.GridPrint;
import net.sf.paperclips.PagePrint;
import net.sf.paperclips.TextPrint;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.ViewPart;

import de.bsvrz.buv.rw.basislib.seiteneinstellungen.druck.vorschau.IDruckvorschau;

/**
 * Dies hier ist Test Sicht die demonstriert, wie im Rahmenwerk gedruckt werden
 * kann.
 * 
 * @author HofmannJ
 * 
 */
public class DruckVorschauTestSicht extends ViewPart implements IDruckvorschau
{

	public static final String ID = "de.bsvrz.buv.plugin.pruefrw.druckvorschau.DruckVorschauTestSicht";
	private Composite top = null;
	private Group gruppeDruckvorschau = null;
	private Text textArea = null;

	@Override
	public void createPartControl(Composite parent)
	{
		top = new Composite(parent, SWT.NONE);
		top.setLayout(new GridLayout());
		createGruppeDruckvorschau();
	}

	@Override
	public void setFocus()
	{
	}

	/**
	 * This method initializes gruppeDruckvorschau
	 * 
	 */
	private void createGruppeDruckvorschau()
	{
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.grabExcessVerticalSpace = true;
		gridData1.verticalAlignment = GridData.FILL;
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.verticalAlignment = GridData.FILL;
		gruppeDruckvorschau = new Group(top, SWT.NONE);
		gruppeDruckvorschau.setLayout(new GridLayout());
		gruppeDruckvorschau.setLayoutData(gridData);
		gruppeDruckvorschau.setText("Druckvorschau Test:");
		textArea = new Text(gruppeDruckvorschau, SWT.MULTI | SWT.WRAP
				| SWT.V_SCROLL);
		textArea
				.setText("Diese View demonstriert, wie Views und Editoren drucken knnen.\n Hierzu muss der Button Druckvorschau im Men vorhanden sein.\nBitte drcken Sie diesen!");
		textArea.setLayoutData(gridData1);
	}

	@Override
	public PagePrint getDruckAuftrag()
	{
		DefaultGridLook look = new DefaultGridLook();
		look.setCellSpacing(5, 2);

		GridPrint grid = new GridPrint("p:g, p:g, p:g, p:g, p:g", look);

		String text = "The quick brown fox jumps over the lazy dog.";
		for (int i = 0; i < 150; i++)
			grid.add(new TextPrint(text));

		PagePrint page = new PagePrint(grid);

		return page;
	}

	@Override
	public String getTitel()
	{
		SimpleDateFormat sdf = new SimpleDateFormat("MM.dd.yyy HH:mm:ss,SSS");		
		return "Testdruckauftrag " + sdf.format(new Date());		
	}

}
