/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.plugin.pruefrw.zeitspezifikationselemente;

import java.util.Date;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.ui.part.ViewPart;

import de.bsvrz.buv.rw.basislib.kalender.CompositeZeitDauer;



public class ViewTestZeitdauer extends ViewPart
{

	public static final String ID = "de.bsvrz.buv.plugin.pruefrw.zeitspezifikationselemente.ViewTestZeitdauer";

	private Composite top = null;
	private Group gruppeDarstellung = null;

	private CompositeZeitDauer _zeitdauer = null;
	private CompositeZeitDauer _zeitdauerOhneStunden = null;
	private CompositeZeitDauer _zeitdauerMitJahresBegrenzung = null;

	private CompositeZeitDauer _zeitdauerKurzform = null;
	private CompositeZeitDauer _zeitdauerKurzformOhneStunden = null;


	@Override
	public void createPartControl(Composite parent)
	{
		top = new Composite(parent, SWT.NONE);
		top.setLayout(new GridLayout());
		createGruppeDarstellung();
	}

	@Override
	public void setFocus()
	{
	}

	/**
	 * This method initializes gruppeDarstellung
	 * 
	 */
	private void createGruppeDarstellung()
	{
		GridData gridDataZeitDauer = new GridData();
		gridDataZeitDauer.horizontalAlignment = GridData.FILL;
		gridDataZeitDauer.grabExcessHorizontalSpace = true;
		gridDataZeitDauer.verticalAlignment = GridData.CENTER;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 1;
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.verticalAlignment = GridData.FILL;
		gruppeDarstellung = new Group(top, SWT.NONE);
		gruppeDarstellung.setText("Darstellung:");
		gruppeDarstellung.setLayout(gridLayout);
		gruppeDarstellung.setLayoutData(gridData);
		// textZeit = new Text(gruppeDarstellung, SWT.BORDER);
		// textZeit.setLayoutData(gridDataZeitDauer);

		// _zeitdauer = new CompositeZeitDauer(gruppeDarstellung, SWT.BORDER, new
		// Date().getTime(), false);
		_zeitdauer = new CompositeZeitDauer(gruppeDarstellung, SWT.BORDER,
				new Date().getTime(), 30333, false);

		_zeitdauer.setLayoutData(gridDataZeitDauer);

		/*
		 * Ohne Stunden
		 */
		_zeitdauerOhneStunden = new CompositeZeitDauer(gruppeDarstellung,
				SWT.BORDER, new Date().getTime(), 30333, false);

		_zeitdauerOhneStunden.setStundenDarstellen(false);
		_zeitdauerOhneStunden.setMonateDarstellen(false);

		_zeitdauerOhneStunden.setLayoutData(gridDataZeitDauer);		
		
		/*
		 * Mit Jahresbegrenzung
		 */
		_zeitdauerMitJahresBegrenzung = new CompositeZeitDauer(gruppeDarstellung,
				SWT.BORDER, new Date().getTime(), 1234430333, false);
		
		_zeitdauerMitJahresBegrenzung.getZeitKlasseJahr().setBeschraenkungMax(10);
		_zeitdauerMitJahresBegrenzung.getZeitKlasseJahr().setBeschraenkungMin(0);
		
		_zeitdauerMitJahresBegrenzung.setLayoutData(gridDataZeitDauer);


		/*
		 * Kurzform
		 */
		_zeitdauerKurzform = new CompositeZeitDauer(gruppeDarstellung, SWT.BORDER,
				new Date().getTime(), 22030333, true);
		_zeitdauerKurzform.setLayoutData(gridDataZeitDauer);

		/*
		 * Kurzform Ohne Stunden
		 */
		_zeitdauerKurzformOhneStunden = new CompositeZeitDauer(gruppeDarstellung,
				SWT.BORDER, new Date().getTime(), 33130333, true);
		_zeitdauerKurzformOhneStunden.setStundenDarstellen(false);
		_zeitdauerKurzformOhneStunden.setMonateDarstellen(false);
		_zeitdauerKurzformOhneStunden.setLayoutData(gridDataZeitDauer);



		
		/*
		 * Unntige Schaltflche
		 */
	}

}
