package de.bsvrz.buv.plugin.syskal;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.plugin.syskal.Eintrag._artDerZeitspezifikation;
import de.bsvrz.buv.rw.basislib.kalender.DatumZeit;
import de.bsvrz.buv.rw.basislib.kalender.DatumZeit.Eingabetyp;
import de.bsvrz.buv.rw.basislib.login.UrlasserDialog;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.sys.funclib.debug.Debug;
import de.bsvrz.vew.syskal.syskal.systemkalendereintrag.SystemkalenderArbeiter;

/**
 * ber den Definitionsdialog muss ein SystemkalenderEintrag neu angelegt bzw. ein existierender Eintrag gendert werden
 * knnen.
 * 
 * <br>
 * <br>
 * Die Klasse erfllt die technische Anforderungen des Segments Bedienung und Visualisierung (BUV): <br>
 * <ul>
 * <li>TAnf-Vi-BW-C3-10</li>
 * <li>TAnf-Vi-BW-C3-11</li>
 * </ul>
 * 
 * @version $Revision: 1.3 $ / $Date: 2010/02/04 06:03:56 $ / ($Author: HofmannJ $)
 * @author HofmannJ
 * 
 */
public class SystemkalenderDefinitionsdialog extends Dialog
{
  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  /**
   * FilterSpeicher.
   */
  private Eintrag _eintrag; // @jve:decl-index=0:

  // private EditorRegulaererAusdruck _editorRegulaererAusdruck = null;
  private Shell shell = null; // @jve:decl-index=0:visual-constraint="96,108"

  private Composite composite = null;

  private CLabel labelName = null;

  private Text textName = null;

  private Group groupFilterDefinitionen = null;

  private Composite compositeFilterDef = null;

  private ScrolledComposite compositeFilterDefScroll = null;

  private Composite compositeBottom = null;

  private Button buttonOk = null;

  private Button buttonAbbrechen = null;

  private Button buttonHilfe = null;

  private Button radioButton1 = null;

  private Button radioButton2 = null;

  private Button radioButton3 = null;

  private Label label1 = null;

  private Label label2 = null;

  private Label label3 = null;

  private Group groupZeitspezifikation = null;

  private Composite compositeZeitBereich = null;

  private Label label4 = null;

  // private Text textAnfangDatum = null;

  // private Text textAnfangZeit = null;

  DatumZeit datumOhneJahr = null;

  DatumZeit zeitVon = null;

  DatumZeit zeitBis = null;

  private Label label5 = null;

  // private Text textEndDatum = null;

  // private Text textEndZeit = null;

  private Composite compositeDatum = null;

  private Label labelDatum = null;

  // private Text textDatum = null;

  private Label labelAnfangJahr = null;

  private Text text = null;

  private Label labelEndJahr = null;

  private Text text1 = null;

  private Composite compositeFreieDef = null;

  private Label labelFreieDef = null;

  private Text textFreieDef = null;

  private DaVKommunikation _daVKommunikation = DaVKommunikation.getInstanz();

  /**
   * Flagge, die das Bearbeiten anzeigt
   */
  private Boolean _bearbeiten = null;

  /**
   * Flagge, die das Kopieren anzeigt
   */
  private Boolean _kopieren = null;

  private Composite composite1;

  private Composite composite2;

  /**
   * Konstruktor fr eine neue Instanz der Klasse {@link SystemkalenderDefinitionsdialog}
   * 
   * @param parent
   *          Eltern-Shell, die fr die Darstellung benutzt werden soll.
   */
  public SystemkalenderDefinitionsdialog(Shell parent)
  {
    super(parent);
    _eintrag = new Eintrag();
    _eintrag.setArtDerZeitspezifikation(Eintrag._artDerZeitspezifikation.Datumseingabe);

  }

  /**
   * ffnet den Dialog {@link SystemkalenderDefinitionsdialog} zum Anlegen eines neuen Systemkalendereintrags.
   * 
   * @return Liefert den erzeugten Systemkalendereintrags als Instanz der Klasse {@link Eintrag}.
   */
  public Eintrag oeffne()
  {
    _bearbeiten = false;
    _kopieren = false;

    Shell parent = getParent();
    shell = new Shell(parent, SWT.TITLE | SWT.APPLICATION_MODAL | SWT.MIN | SWT.MAX | SWT.CLOSE);
    // shell = new Shell();
    shell.setText("Definition Systemkalender");
    shell.setLayout(new GridLayout());
    createComposite();
    createFilterdefintion();
    createGroupZeitspezifikation();
    createCompositeBottom();
    shell.setSize(new Point(361, 310));

    shell.open();

    Display display = parent.getDisplay();

    while (!shell.isDisposed())
      if (!display.readAndDispatch())
        display.sleep();

    return _eintrag;
  }

  /**
   * ffnet den Dialog {@link SystemkalenderDefinitionsdialog} zum Bearbeiten und Kopieren eines bereits erzeugten
   * Systemkalendereintrags.
   * 
   * @param eintrag
   *          Systemkalendereintrag, der bearbeitet werden soll.
   * @param kopieren
   *          zeigt an, ob der eintrag bearbeitet oder kopiert werden soll
   * @return eintrag Liefert den bearbeiteten Eintrag
   */
  public Eintrag oeffne(Eintrag eintrag, boolean kopieren)
  {
    _kopieren = kopieren;
    _bearbeiten = true;
    _eintrag = eintrag;

    Shell parent = getParent();
    shell = new Shell(parent, SWT.TITLE | SWT.APPLICATION_MODAL | SWT.MIN | SWT.MAX | SWT.CLOSE);
    // shell = new Shell();
    shell.setText("Definition Systemkalender");
    shell.setLayout(new GridLayout());
    createComposite();
    createFilterdefintion();
    createGroupZeitspezifikation(eintrag.getArtDerZeitspezifikation());
    createCompositeBottom();
    shell.setSize(new Point(361, 310));

    textName.setText(_eintrag.getName());
    if (!_kopieren)
      textName.setEnabled(false);

    if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.Datumseingabe))
    {

      textName.setText(eintrag.getName());

      String datum = _eintrag.getDatum();

      String[] split = datum.split("[.,]");

      SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy");

      try
      {
        Date d = null;
        Date d1 = null;
        Calendar cal = new GregorianCalendar().getInstance();
        if (!split[2].equals("*"))
          d = sdf.parse(split[0] + "." + split[1] + "." + split[2]);
        else
        {
          d = sdf.parse(split[0] + "." + split[1] + "." + cal.get(Calendar.YEAR));
        }
        if (!split[3].equals("*"))
          d1 = sdf.parse(split[0] + "." + split[1] + "." + split[3]);
        else
        {
          d1 = sdf.parse(split[0] + "." + split[1] + "." + cal.get(Calendar.YEAR));
        }

        datumOhneJahr.setDatum(d);
      }
      catch (ParseException e)
      {
        e.printStackTrace();
      }

      // textDatum.setText(split[0] + "." + split[1] + ".");
      text.setText(split[2]);
      text1.setText(split[3]);

      radioButton1.setSelection(true);
      radioButton2.setSelection(false);
      radioButton3.setSelection(false);

      radioButton1.setEnabled(false);
      radioButton2.setEnabled(false);
      radioButton3.setEnabled(false);

      shell.open();

    }
    else if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.Zeitbereichsangabe))
    {

      textName.setText(eintrag.getName());

      // String anfang = _eintrag.getAnfangsZeitpunkt();
      // String[] split1 = anfang.split("[ ]");

      // String ende = _eintrag.getEndZeitpunkt();
      // String[] split2 = ende.split("[ ]");

      // textAnfangDatum.setText(split1[0]);
      // textAnfangZeit.setText(split1[1]);
      // textEndDatum.setText(split2[0]);
      // textEndZeit.setText(split2[1]);
      Date von = new Date();
      Date bis = new Date();
      von.setTime(_eintrag.getAnfangsZeitpunkt());
      bis.setTime(_eintrag.getEndZeitpunkt());
      zeitVon.setDatum(von);
      zeitBis.setDatum(bis);

      radioButton1.setSelection(false);
      radioButton2.setSelection(true);
      radioButton3.setSelection(false);

      radioButton1.setEnabled(false);
      radioButton2.setEnabled(false);
      radioButton3.setEnabled(false);

      shell.open();

    }
    else if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.FreieDefinition))
    {

      textName.setText(eintrag.getName());
      String s = _eintrag.getFreieDefinition();
      textFreieDef.setText(s);

      radioButton1.setSelection(false);
      radioButton2.setSelection(false);
      radioButton3.setSelection(true);

      radioButton1.setEnabled(false);
      radioButton2.setEnabled(false);
      radioButton3.setEnabled(false);

      shell.open();

    }
    else if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.VordefinierterEintrag))
    {
      textName.setText(eintrag.getName());
      String s = _eintrag.getVordefinierterEintrag();
      textFreieDef.setText(s);
      if (!kopieren)
      {
        textFreieDef.setEnabled(false);
        buttonOk.setEnabled(false);
      }

      radioButton1.setSelection(false);
      radioButton2.setSelection(false);
      radioButton3.setSelection(true);

      radioButton1.setEnabled(false);
      radioButton2.setEnabled(false);
      radioButton3.setEnabled(false);

      shell.open();

    }
    // else if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.VordefinierterEintrag))
    // {
    //
    // MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
    // mb.setText("Fehler");
    // if (_kopieren)
    // mb.setMessage("Ein vordefinierter Eintrag kann nicht kopiert werden!");
    // else
    // mb.setMessage("Ein vordefinierter Eintrag kann nicht bearbeitet werden!");
    // mb.open();
    //
    // }

    Display display = parent.getDisplay();

    while (!shell.isDisposed())
      if (!display.readAndDispatch())
        display.sleep();

    return eintrag;
  }

  /**
   * bernimmt die aktuellen Einstellungen. Dabei wird geprft,
   * <ul>
   * <li>ob eine Filterdefinition eingegeben wurde</li>
   * <li>dass ein Name eingegeben wurde</li>
   * </ul>
   * 
   */
  private void aktionOk()
  {

    String pid = null;
    String name = null;
    String definition = null;

    if (textName.getText().length() > 0)
    {

      if (!_bearbeiten || _kopieren)
        pid = "ske." + textName.getText().replaceAll(" ", "");
      else
      {
        pid = _eintrag.getPid();

      }

      name = textName.getText();

      if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.Datumseingabe))
      {

        Calendar cal = new GregorianCalendar().getInstance();
        Date datum = datumOhneJahr.getDatum();

        SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.");
        String format = sdf.format(datum);

        String t1 = text.getText();
        if (!t1.equals("*"))
        {

          boolean b = false;

          Integer i = null;
          try
          {
            i = new Integer(t1);
          }
          catch (NumberFormatException e)
          {
            b = true;
          }

          if (!b)
          {
            if (i < 0)
              b = true;
          }

          SimpleDateFormat sdf1 = new SimpleDateFormat("dd.MM.yyyy");
          sdf1.setLenient(false);

          try
          {
            sdf1.parse(format + t1);
          }
          catch (ParseException e)
          {
            // e.printStackTrace();
            b = true;
          }

          if (b)
          {
            MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
            mb.setText("Fehler Definition");
            mb.setMessage("Fehler Datum: " + format + t1);
            mb.open();
            return;
          }
        }

        String t2 = text1.getText();

        if (!t2.equals("*"))
        {

          boolean b = false;

          Integer i = null;
          try
          {
            i = new Integer(t2);
          }
          catch (NumberFormatException e)
          {
            b = true;
          }

          if (i != null)
          {
            if (i < 0)
              b = true;
          }

          SimpleDateFormat sdf2 = new SimpleDateFormat("dd.MM.yyyy");
          sdf2.setLenient(false);

          try
          {
            sdf2.parse(format + t2);
          }
          catch (ParseException e)
          {
            // e.printStackTrace();
            b = true;
          }

          if (b)
          {
            MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
            mb.setText("Fehler Definition");
            mb.setMessage("Fehler Datum: " + format + t2);
            mb.open();
            return;
          }
        }

        // definition = name + ":=" + textDatum.getText() + text.getText() + "," + text1.getText();
        definition = name + ":=" + format + t1 + "," + t2;

      }
      else if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.Zeitbereichsangabe))
      {

        SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy HH:mm:ss,SSS");
        String s1 = sdf.format(zeitVon.getDatum());
        String s2 = sdf.format(zeitBis.getDatum());
   
        // definition = name + ":=" + "<" + textAnfangDatum.getText() + " " + textAnfangZeit.getText() + ":00,000-"
        // + textEndDatum.getText() + " " + textEndZeit.getText() + ":59,999>";

        definition = name + ":=" + "<" + s1 + "-" + s2 + ">";
        
        if (zeitVon.getDatum().getTime() > zeitBis.getDatum().getTime())
        {
          MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
          mb.setText("Fehler Definition");
          mb.setMessage("Fehler Zeitbereichseingabe: " + definition);
          mb.open();
          return;
        }

      }
      else if (_eintrag.getArtDerZeitspezifikation().equals(Eintrag._artDerZeitspezifikation.FreieDefinition))
      {

        definition = name + ":=" + textFreieDef.getText();

      }

    }
    else
    {
      MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
      mb.setText("Fehler Definition");
      mb.setMessage("Kein Name angegeben");
      mb.open();
      return;
    }

    if (pid != null && name != null && definition != null)
    {

      Boolean gueltig = null;

      if (definition.contains(":="))
      {

        String[] split = definition.split(":=");

        try
        {
          // gueltig = parserSke.parseSystemkalenderEintrag(pid, split[0], split[1]);
          // SystemkalenderArbeiter arbeiter = SystemkalenderArbeiter.getInstanz();
          // if (!_daVKommunikation.isObjektVorhanden(pid)){
          gueltig = SystemkalenderArbeiter.parseSystemkalenderEintrag(pid, split[0], split[1]);
          // }else{
          // MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
          // mb.setText("Fehler Definition");
          // mb.setMessage("Es ist bereits ein Eintrag vorhanden: " + pid);
          // mb.open();
          // return;
          // }

        }
        catch (Exception e)
        {
          gueltig = false;

        }

      }
      else
      {
        gueltig = false;
      }

      if (gueltig)
      {

        _eintrag.setPid(pid);
        _eintrag.setName(name);
        // _eintrag.setDatum(definition);

        if (!_daVKommunikation.isObjektVorhanden(pid))
        {
          _daVKommunikation.erzeugeSystemKalenderEintrag(pid, name);
        }
        else
        {

          List<Eintrag> es = _daVKommunikation.getSystemKalenderEintraege();
          Eintrag vorhanden = null;
          for (Eintrag e : es)
          {
            if (e.getPid().equals(_eintrag.getPid()))
            {
              vorhanden = e;
            }
          }

          if (vorhanden != null)
          {

            if (!_bearbeiten || _kopieren)
            {
              MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
              mb.setText("Fehler Definition");
              mb.setMessage("Es ist bereits ein Eintrag vorhanden: " + pid);
              mb.open();
              return;
            }

          }
        }

        DataModel dataModel = _daVKommunikation.holeDaVVerbindung().getDataModel();

        AttributeGroup atg = dataModel.getAttributeGroup("atg.systemKalenderEintrag");
        Aspect asp = dataModel.getAspect("asp.parameterVorgabe");
        Data data = _daVKommunikation.holeDaVVerbindung().createData(atg);
        data.getItem("Definition").asTextValue().setText(definition);

        ResultData resultData = new ResultData(dataModel.getObject(pid), new DataDescription(atg, asp), new Date()
            .getTime(), data);
        List<ResultData> list = new ArrayList<ResultData>();
        list.add(resultData);

        UrlasserDialog urlasserDialog = new UrlasserDialog(shell);

        if (!(urlasserDialog.anzeigen(list)).getEingabeOk() && !_bearbeiten)
          _daVKommunikation.loescheSystemKalenderEintrag(pid);

        shell.dispose();

      }
      else
      {
        MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
        mb.setText("Fehler Definition");
        mb.setMessage("Definition nicht gltig : " + definition);
        mb.open();
        return;
      }

    }
    else
    {
      MessageBox mb = new MessageBox(new Shell(Display.getCurrent()), SWT.ICON_INFORMATION | SWT.OK);
      mb.setText("Fehler Definition");
      mb.setMessage("Definition nicht vollstndig : " + _eintrag.getName());
      mb.open();
      return;
    }

  }

  /**
   * Schliet den Dialog {@link SystemkalenderDefinitionsdialog} ohne bernahme der Einstellungen.
   * 
   */
  private void aktionAbbrechen()
  {
    _eintrag = null;
    shell.dispose();
  }

  /**
   * Zeigt die Hilfe zum Dialog {@link SystemkalenderDefinitionsdialog} an.
   * 
   */
  private void aktionHilfe()
  {
    String contextId = Aktivator.PLUGIN_ID + ".systemkalender";
    _debug.fine("ContextID: " + contextId);
    PlatformUI.getWorkbench().getHelpSystem().displayHelp(contextId);
  }

  /**
   * This method initializes composite
   * 
   */
  private void createComposite()
  {
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.verticalAlignment = GridData.CENTER;
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 2;
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.CENTER;
    composite = new Composite(shell, SWT.NONE);
    composite.setLayoutData(gridData);
    composite.setLayout(gridLayout);
    labelName = new CLabel(composite, SWT.NONE);
    labelName.setText("Name");
    textName = new Text(composite, SWT.BORDER);
    textName.setLayoutData(gridData1);
    textName.addModifyListener(new ModifyListener() {

      @Override
      public void modifyText(ModifyEvent e)
      {
        _eintrag.setName(textName.getText());

      }
    });

  }

  /**
   * This method initializes Filterdefintion
   * 
   */
  private void createFilterdefintion()
  {
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessVerticalSpace = false;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.verticalAlignment = GridData.CENTER;
    groupFilterDefinitionen = new Group(shell, SWT.NONE);
    groupFilterDefinitionen.setLayout(new FillLayout());
    groupFilterDefinitionen.setLayoutData(gridData2);
    createCompositeFilterDef();
    groupFilterDefinitionen.setText("Art der Zeitspezifikation");
  }

  /**
   * This method initializes compositeFilterDef
   * 
   */
  private void createCompositeFilterDef()
  {

    GridData gridData9 = new GridData();
    gridData9.horizontalAlignment = GridData.FILL;
    gridData9.verticalAlignment = GridData.CENTER;
    GridData gridData7 = new GridData();
    gridData7.horizontalAlignment = GridData.FILL;
    gridData7.verticalAlignment = GridData.CENTER;
    GridData gridData6 = new GridData();
    gridData6.horizontalAlignment = GridData.FILL;
    gridData6.grabExcessHorizontalSpace = true;
    gridData6.verticalAlignment = GridData.CENTER;
    GridLayout gridLayout1 = new GridLayout();
    gridLayout1.numColumns = 2;
    GridData gridData8 = new GridData();
    gridData8.horizontalAlignment = GridData.FILL;
    gridData8.grabExcessHorizontalSpace = true;
    gridData8.verticalAlignment = GridData.CENTER;

    compositeFilterDefScroll = new ScrolledComposite(groupFilterDefinitionen, SWT.H_SCROLL | SWT.V_SCROLL);

    compositeFilterDef = new Composite(compositeFilterDefScroll, SWT.NONE);
    compositeFilterDef.setLayout(gridLayout1);
    radioButton1 = new Button(compositeFilterDef, SWT.RADIO);
    radioButton1.setSelection(true);

    radioButton1.addSelectionListener(new SelectionAdapter() {
      @Override
      public void widgetSelected(SelectionEvent e)
      {
        if (radioButton1.getSelection())
        {
          createCompositeDatum();
          compositeZeitBereich.dispose();
          compositeFreieDef.dispose();
          groupZeitspezifikation.layout();

          _eintrag.setArtDerZeitspezifikation(Eintrag._artDerZeitspezifikation.Datumseingabe);

        }

      }

    });

    label1 = new Label(compositeFilterDef, SWT.NONE);
    label1.setText("Datumseingabe");
    radioButton2 = new Button(compositeFilterDef, SWT.RADIO);
    radioButton2.addSelectionListener(new SelectionAdapter() {
      @Override
      public void widgetSelected(SelectionEvent e)
      {
        if (radioButton2.getSelection())
        {
          createCompositeZeitBereich();
          compositeDatum.dispose();
          compositeFreieDef.dispose();
          groupZeitspezifikation.layout();

          _eintrag.setArtDerZeitspezifikation(Eintrag._artDerZeitspezifikation.Zeitbereichsangabe);

        }
      }

    });
    label2 = new Label(compositeFilterDef, SWT.NONE);
    label2.setText("Zeitbereichseingabe");
    radioButton3 = new Button(compositeFilterDef, SWT.RADIO);
    radioButton3.addSelectionListener(new SelectionAdapter() {
      @Override
      public void widgetSelected(SelectionEvent e)
      {
        if (radioButton3.getSelection())
        {
          createCompositeFreieDef();
          compositeDatum.dispose();
          compositeZeitBereich.dispose();
          groupZeitspezifikation.layout();

          _eintrag.setArtDerZeitspezifikation(Eintrag._artDerZeitspezifikation.FreieDefinition);

        }
      }

    });

    label3 = new Label(compositeFilterDef, SWT.NONE);
    label3.setText("Freie Definition");

    compositeFilterDefScroll.setContent(compositeFilterDef);
    compositeFilterDef.layout();
    compositeFilterDefScroll.setLayout(new FillLayout());
    compositeFilterDefScroll.setExpandHorizontal(true);
    compositeFilterDefScroll.setExpandVertical(true);

    compositeFilterDefScroll.setMinSize(compositeFilterDef.computeSize(SWT.DEFAULT, SWT.DEFAULT));
    compositeFilterDef.layout();

  }

  /**
   * This method initializes compositeBottom
   * 
   */
  private void createCompositeBottom()
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.END;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.CENTER;
    compositeBottom = new Composite(shell, SWT.NONE);
    compositeBottom.setLayoutData(gridData3);
    compositeBottom.setLayout(rowLayout);
    buttonOk = new Button(compositeBottom, SWT.NONE);
    buttonOk.setText("Ok");
    buttonOk.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionOk();
			}			
		});

    buttonAbbrechen = new Button(compositeBottom, SWT.NONE);
    buttonAbbrechen.setText("Abbrechen");
    buttonAbbrechen.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionAbbrechen();
			}			
		});
    
    buttonHilfe = new Button(compositeBottom, SWT.NONE);
    buttonHilfe.setText("Hilfe");
    buttonHilfe.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionHilfe();
			}			
		});
  }

  /**
   * This method initializes groupZeitspezifikation
   * 
   */
  private void createGroupZeitspezifikation()
  {
    GridData gridData4 = new GridData();
    gridData4.horizontalAlignment = GridData.FILL;
    gridData4.grabExcessVerticalSpace = true;
    gridData4.grabExcessHorizontalSpace = true;
    gridData4.verticalAlignment = GridData.FILL;
    groupZeitspezifikation = new Group(shell, SWT.NONE);
    groupZeitspezifikation.setLayout(new GridLayout());

    createCompositeDatum();
    createCompositeZeitBereich();
    createCompositeFreieDef();

    compositeZeitBereich.dispose();
    compositeFreieDef.dispose();

    groupZeitspezifikation.setLayoutData(gridData4);
    groupZeitspezifikation.setText("Zeitspezifikation");

    groupZeitspezifikation.layout();
  }

  /**
   * This method initializes groupZeitspezifikation
   * 
   */
  private void createGroupZeitspezifikation(_artDerZeitspezifikation art)
  {
    GridData gridData4 = new GridData();
    gridData4.horizontalAlignment = GridData.FILL;
    gridData4.grabExcessVerticalSpace = true;
    gridData4.grabExcessHorizontalSpace = true;
    gridData4.verticalAlignment = GridData.FILL;
    groupZeitspezifikation = new Group(shell, SWT.NONE);
    groupZeitspezifikation.setLayout(new GridLayout());

    if (art.equals(Eintrag._artDerZeitspezifikation.Datumseingabe))
      createCompositeDatum();
    else if (art.equals(Eintrag._artDerZeitspezifikation.Zeitbereichsangabe))
      createCompositeZeitBereich();
    else if (art.equals(Eintrag._artDerZeitspezifikation.FreieDefinition))
      createCompositeFreieDef();
    else if (art.equals(Eintrag._artDerZeitspezifikation.VordefinierterEintrag))
      createCompositeFreieDef();

    // compositeZeitBereich.dispose();
    // compositeFreieDef.dispose();

    groupZeitspezifikation.setLayoutData(gridData4);
    groupZeitspezifikation.setText("Zeitspezifikation");

    groupZeitspezifikation.layout();
  }

  /**
   * This method initializes compositeFreieDef
   * 
   */
  private void createCompositeFreieDef()
  {
    GridData gridData10 = new GridData();
    gridData10.horizontalAlignment = GridData.FILL;
    gridData10.grabExcessHorizontalSpace = true;
    gridData10.verticalAlignment = GridData.CENTER;
    GridLayout gridLayout2 = new GridLayout();
    gridLayout2.numColumns = 2;
    GridData gridData5 = new GridData();
    gridData5.horizontalAlignment = GridData.FILL;
    gridData5.grabExcessHorizontalSpace = true;
    gridData5.grabExcessVerticalSpace = true;
    gridData5.verticalAlignment = GridData.FILL;
    compositeFreieDef = new Composite(groupZeitspezifikation, SWT.NONE);
    compositeFreieDef.setLayoutData(gridData5);
    compositeFreieDef.setLayout(gridLayout2);
    labelFreieDef = new Label(compositeFreieDef, SWT.NONE);
    labelFreieDef.setText("Freie Definition");
    textFreieDef = new Text(compositeFreieDef, SWT.BORDER);
    textFreieDef.setLayoutData(gridData10);

  }

//   /**
//   * This method initializes compositeDatum
//   *
//   */
//   private void createCompositeDatum()
//   {
//   GridLayout gridLayout2 = new GridLayout();
//   gridLayout2.numColumns = 4;
//   GridData gridData5 = new GridData();
//   gridData5.horizontalAlignment = GridData.CENTER;
//   gridData5.grabExcessHorizontalSpace = false;
//   gridData5.grabExcessVerticalSpace = false;
//   gridData5.verticalAlignment = GridData.CENTER;
//   GridData gridData10 = new GridData();
//   gridData10.horizontalAlignment = GridData.FILL;
//   gridData10.grabExcessHorizontalSpace = true;
//   gridData10.verticalAlignment = GridData.CENTER;
//   compositeDatum = new Composite(groupZeitspezifikation, SWT.NONE);
//   compositeDatum.setLayoutData(gridData5);
//   compositeDatum.setLayout(gridLayout2);
//   labelDatum = new Label(compositeDatum, SWT.NONE);
//   labelDatum.setText("Datum");
//   //textDatum = new Text(compositeDatum, SWT.BORDER);
//   datumOhneJahr = new DatumZeit(compositeDatum, SWT.NONE, Eingabetyp.datumOhneJahr, false, false);
//   datumOhneJahr.setLayoutData(gridData10);
//   Label filler = new Label(compositeDatum, SWT.NONE);
//   Label filler1 = new Label(compositeDatum, SWT.NONE);
//   labelAnfangJahr = new Label(compositeDatum, SWT.NONE);
//   labelAnfangJahr.setText("Jahr Anfang");
//   text = new Text(compositeDatum, SWT.BORDER);
//   labelEndJahr = new Label(compositeDatum, SWT.NONE);
//   labelEndJahr.setText("Jahr Ende");
//   text1 = new Text(compositeDatum, SWT.BORDER);
//   }

  /**
   * This method initializes compositeDatum
   * 
   */
  private void createCompositeDatum()
  {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.grabExcessVerticalSpace = true;
    gridData.verticalAlignment = GridData.FILL;
    compositeDatum = new Composite(groupZeitspezifikation, SWT.NONE);
    compositeDatum.setLayout(new GridLayout());
    compositeDatum.setLayoutData(gridData);
    createComposite1();
    createComposite2();
  }

  /**
   * This method initializes composite2
   * 
   */
  private void createComposite2()
  {
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 4;
    composite2 = new Composite(compositeDatum, SWT.NONE);
    composite2.setLayout(gridLayout);
    labelAnfangJahr = new Label(composite2, SWT.NONE);
    labelAnfangJahr.setText("Jahr Anfang");
    text = new Text(composite2, SWT.BORDER);
    labelEndJahr = new Label(composite2, SWT.NONE);
    labelEndJahr.setText("Jahr Ende");
    text1 = new Text(composite2, SWT.BORDER);
  }

  /**
   * This method initializes composite1
   * 
   */
  private void createComposite1()
  {
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.verticalAlignment = GridData.CENTER;
    GridLayout gridLayout2 = new GridLayout();
    gridLayout2.numColumns = 2;
    composite1 = new Composite(compositeDatum, SWT.NONE);
    composite1.setLayout(gridLayout2);
    labelDatum = new Label(composite1, SWT.NONE);
    labelDatum.setText("Datum");
    // textDatum = new Text(compositeDatum, SWT.BORDER);
    datumOhneJahr = new DatumZeit(composite1, SWT.NONE, Eingabetyp.datumOhneJahr, false, false);
    datumOhneJahr.setLayoutData(gridData2);
  }

  /**
   * This method initializes compositeZeitSpec
   * 
   */
  private void createCompositeZeitBereich()
  {
    GridData gridData12 = new GridData();
    gridData12.horizontalAlignment = GridData.BEGINNING;
    gridData12.verticalAlignment = GridData.CENTER;
    GridData gridData10 = new GridData();
    gridData10.horizontalAlignment = GridData.FILL;
    gridData10.grabExcessHorizontalSpace = true;
    gridData10.verticalAlignment = GridData.CENTER;
    GridData gridData11 = new GridData();
    gridData11.horizontalAlignment = GridData.FILL;
    gridData11.grabExcessHorizontalSpace = true;
    gridData11.verticalAlignment = GridData.CENTER;
    GridLayout gridLayout2 = new GridLayout();
    gridLayout2.numColumns = 2;
    compositeZeitBereich = new Composite(groupZeitspezifikation, SWT.NONE);
    compositeZeitBereich.setLayout(gridLayout2);
    compositeZeitBereich.setLayoutData(gridData12);
    label4 = new Label(compositeZeitBereich, SWT.NONE);
    label4.setText("Anfangszeitpunkt");
    // textAnfangDatum = new Text(compositeZeitBereich, SWT.BORDER);
    // textAnfangZeit = new Text(compositeZeitBereich, SWT.BORDER);
    // textAnfangZeit.setLayoutData(gridData10);
    zeitVon = new DatumZeit(compositeZeitBereich, SWT.NONE, Eingabetyp.datumuhrEinfach, false, false);
    zeitVon.setLayoutData(gridData10);
    label5 = new Label(compositeZeitBereich, SWT.NONE);
    label5.setText("Endzeitpunkt");
    // textEndDatum = new Text(compositeZeitBereich, SWT.BORDER);
    // textEndZeit = new Text(compositeZeitBereich, SWT.BORDER);
    zeitBis = new DatumZeit(compositeZeitBereich, SWT.NONE, Eingabetyp.datumuhrEinfach, false, false);
    zeitBis.setLayoutData(gridData11);
  }

}
