/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.einstellungen.hilfsklassen;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.StringFieldEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import de.bsvrz.buv.rw.basislib.Activator;

public class PraeferenzSeiteVoreinstellungenOptionen extends
		FieldEditorPreferencePage implements IWorkbenchPreferencePage
{
	public PraeferenzSeiteVoreinstellungenOptionen()
	{
		super(org.eclipse.jface.preference.FieldEditorPreferencePage.GRID);
		setPreferenceStore(Activator.getDefault().getPreferenceStore());
		setDescription("Hier werden die Speicheroptionen fr den Einstellungenspeicher festgelegt.");
	}

	@Override
	public void init(IWorkbench workbench)
	{
	}

	public void createControl(Composite parent)
	{
		super.createControl(parent);
	}

	@Override
	protected void createFieldEditors()
	{
		Composite composite = getFieldEditorParent();

		addField(new BooleanFieldEditor(
				DefinitionenEinstellungen.PARAM_EINTRAG_ERGAENZEN, "Eintrag ergnzen",
				composite));
		addField(new StringFieldEditor(
				DefinitionenEinstellungen.PARAM_START_STRING, "Start-String", composite));
		addField(new StringFieldEditor(DefinitionenEinstellungen.PARAM_ENDE_STRING,
				"Ende-String", composite));

	}

}
