/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.listendarstellung;

import java.util.Iterator;

public class ZelleTest
{

  /**
   * @param args
   */
  public static void main(String[] args)
  {
    @SuppressWarnings("unused")
    ZelleTest zt = new ZelleTest();
  }

  public ZelleTest()
  {
    Zelle liste = new Zelle("Liste");
    liste.setListe(true);

    Zelle array = new Zelle("Array");
    array.setArray(true);
    liste.addToList(array);

    Zelle a1 = new Zelle("ArraySub1");
    a1.setPlain(true);
    Zelle a2 = new Zelle("ArraySub2");
    a2.setPlain(true);
    Zelle a3 = new Zelle("ArraySub3");
    a3.setPlain(true);
    Zelle listeA4 = new Zelle("ArraySub4Liste");
    listeA4.setListe(true);

    array.addToArray(a1);
    array.addToArray(a2);
    array.addToArray(a3);
    // array.addToArray(listeA4);

    Zelle array2 = new Zelle("Array2");
    array2.setArray(true);
    liste.addToList(array2);

    Zelle array2Liste1 = new Zelle("Array2.Liste1");
    array2Liste1.setListe(true);
    array2.addToArray(array2Liste1);

    Zelle array2Liste1Plain1 = new Zelle("Array2.Liste1.Plain1");
    array2Liste1Plain1.setPlain(true);
    array2Liste1.addToList(array2Liste1Plain1);

    Zelle array2Liste1Plain2 = new Zelle("Array2.Liste1.Plain2");
    array2Liste1Plain2.setPlain(true);
    array2Liste1.addToList(array2Liste1Plain2);

    Zelle array2Liste2 = new Zelle("Array2.Liste2");
    array2Liste2.setListe(true);
    array2.addToArray(array2Liste2);

    Zelle array2Liste2Plain1 = new Zelle("Array2.Liste2.Plain1");
    array2Liste2Plain1.setPlain(true);
    array2Liste2.addToList(array2Liste2Plain1);

    Zelle array2Liste2Plain2 = new Zelle("Array2.Liste2.Plain2");
    array2Liste2Plain2.setPlain(true);
    array2Liste2.addToList(array2Liste2Plain2);

    Zelle plainInList = new Zelle("Liste.3.Plain.1");
    plainInList.setPlain(true);
    liste.addToList(plainInList);

    int ebene = a1.bestimmeStartPosY(a1);
    System.out.println("Ebene: " + ebene);

    int spalte = a3.getSpalte(a3);
    System.out.println("Spalte: " + spalte);

    System.out.println("Breite Liste: " + liste.getBreite(liste));

    System.out.println("StartPosX array2Liste1Plain2: " + array2Liste1Plain2.bestimmeStartPosX(array2Liste1Plain2));
    System.out.println("Tiefe von array2Liste1Plain2: " + array2Liste1Plain2.bestimmeStartPosY(array2Liste1Plain2));

    System.out.println("StartPosX array2Liste2Plain2: " + array2Liste2Plain2.bestimmeStartPosX(array2Liste2Plain2));
    System.out.println("Tiefe von array2Liste2Plain2: " + array2Liste2Plain2.bestimmeStartPosY(array2Liste2Plain2));

    System.out.println("Breite array2: " + array2.getBreite(array2));
    System.out.println("Breite liste: " + liste.getBreite(liste));
    System.out.println("Liste StartPosX: " + liste.bestimmeStartPosX(liste) + " Liste EndPosX: "
        + liste.bestimmeEndPosX(liste));

    Zelle vorgaengerListe = array2Liste2Plain2.bestimmeVorgaengerListe(array2Liste2Plain2);
    System.out.println("Vorgngerlist: " + vorgaengerListe);

    Zelle bestimtmeVorgaengerListe = plainInList.bestimmeVorgaengerListe(plainInList);
    int tiefstesArrayInNachfolgenderZelle = bestimtmeVorgaengerListe
        .bestimmeTiefstesElementImTiefstenArrayInNachfolgenderZelle(bestimtmeVorgaengerListe);
    System.out.println("Tiefstes Array: " + tiefstesArrayInNachfolgenderZelle);

    System.out.println("SIZE: " + array2Liste2Plain2.bestimmeAlleZellen().size());
    System.out.println("SIZE: " + array2.bestimmeAlleZellen().size());

    Iterator<Zelle> it = array2Liste2Plain2.bestimmeAllePlainZellen().iterator();
    int i = 0;
    while (it.hasNext())
    {
      Zelle zelle = it.next();

      zelle.setStartX(zelle.bestimmeStartPosX(zelle));
      zelle.setStartY(zelle.bestimmeStartPosY(zelle));
      zelle.setEndX(zelle.bestimmeEndPosX(zelle));
      zelle.setEndY(zelle.bestimmeEndPosY(zelle));

      System.out.println("ZELLE #" + i + ": " + zelle);

      i++;
    }

    System.out.println("WERT: " + liste.bestimmeMaxTiefeInZelle(liste));

  }

}
