/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.menu.editoren;

import java.util.EventObject;

import de.bsvrz.buv.rw.rw.menu.xml.datenstruktur.EreignisMenuSymbolLeisteDatenGeandert;
import de.bsvrz.buv.rw.rw.menu.xml.datenstruktur.IZuhoererMenuSymbolLeisteDatenAenderung;
import de.bsvrz.buv.rw.rw.menu.xml.datenstruktur.MenuSymbolLeisteDaten;

/**
 * Event fr {@link EditorMenuSymbolLeisteEditor}. Sobald in {@link EditorMenuSymbolLeisteEditor} eine nderung
 * gespeichert wird, wird dieser Event ausgelst.
 * 
 * @version $Revision: 1.1 $ / $Date: 2009/12/02 09:19:30 $ / ($Author: HofmannJ $)
 * 
 * @deprecated {@link MenuSymbolLeisteDaten} und {@link EreignisMenuSymbolLeisteDatenGeandert} sowie
 *             {@link IZuhoererMenuSymbolLeisteDatenAenderung} verwenden.
 * 
 * @author HofmannJ
 * 
 */
public class EreignisMenuLeisteGeandert extends EventObject
{

  /**
   * Feld fr die Serialisierung
   */
  private static final long serialVersionUID = 9153897306378786843L;

  /**
   * Konstruktor fr ein EventObject.
   * 
   * @param source
   *          Objekt, von dem das Ereignis ausgelst wurde.
   */
  public EreignisMenuLeisteGeandert(Object source)
  {
    super(source);
  }

  /**
   * Liefert die Daten des Events
   * 
   * @return Liefert true, wenn der Event eingetreten ist.
   */
  public boolean getDaten()
  {
    // return source;
    return true;
  }

}
