/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.status;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * Diese Klasse liefert nur einen Rahmen, damit das Composite StatusComposite auch ausserhalb der RCP, d.h. schneller
 * getestet werden kann.
 * 
 * @author HofmannJ
 * 
 */
public class StatusAnzeiger
{

  private Shell sShell = null;

  private Text textFeld = null;

  private Button buttonOk = null;

  private Group groupTestGruppe = null;

  /**
   * This method initializes groupTestGruppe
   * 
   */
  private void createGroupTestGruppe()
  {
    groupTestGruppe = new Group(sShell, SWT.NONE);
    groupTestGruppe.setLayout(new FillLayout());
    groupTestGruppe.setText("Testgruppe");
    @SuppressWarnings("unused")
		StatusComposite sc = new StatusComposite(groupTestGruppe, SWT.NONE);
  }

  /**
   * @param args
   */
  public static void main(String[] args)
  {
    /*
     * Before this is run, be sure to set up the launch configuration (Arguments->VM Arguments) for the correct SWT
     * library path in order to run with the SWT dlls. The dlls are located in the SWT plugin jar. For example, on
     * Windows the Eclipse SWT 3.1 plugin jar is: installation_directory\plugins\org.eclipse.swt.win32_3.1.0.jar
     */
    Display display = Display.getDefault();
    StatusAnzeiger thisClass = new StatusAnzeiger();
    thisClass.createSShell();
    thisClass.sShell.open();

    while (!thisClass.sShell.isDisposed())
    {
      if (!display.readAndDispatch())
        display.sleep();
    }
    display.dispose();
  }

  /**
   * This method initializes sShell
   */
  private void createSShell()
  {
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 2;
    sShell = new Shell();
    sShell.setText("Shell");
    sShell.setLayout(gridLayout);
    sShell.setSize(new Point(400, 400));
    textFeld = new Text(sShell, SWT.BORDER);
    buttonOk = new Button(sShell, SWT.NONE);
    buttonOk.setText("OK");
    createGroupTestGruppe();
    buttonOk.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				 textFeld.setText("OK!");
	        sShell.dispose();
			}			
		});
  }

}
