/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.rw.ui.internal;

public interface IRWMenuConstants
{

  /**
   * Name des Standard-Darstellung-Menus (Wert <code>"darstellung"</code>)
   */
  String MENU_DARSTELLUNG = "darstellung";

  /**
   * Darstellungsmenu: Bereich fuer die Aktion "Netzansicht" (Wert <code>"netzansicht"</code>)
   */
  String NETZANSICHT = "netzansicht";

  /**
   * Darstellungsmenu: Bereich fuer die Aktion "SBA" (Wert <code>"sba"</code>)
   */
  String SBA = "sba";

  /**
   * Darstellungsmenu: Bereich fuer die Aktion "NBA" (Wert <code>"nba"</code>)
   */
  String NBA = "nba";

  /**
   * Darstellungsmenu: Bereich fuer die Aktion "Streckenprofil" (Wert <code>"streckenprofil"</code>)
   * 
   */
  String STRECKENPROFIL = "streckenprofil";

  /**
   * Darstellungsmenu: Bereich fuer die Aktion "Anlagenstatus" (Wert <code>"anlagenstatus"</code>)
   * 
   */
  String ANLAGENSTATUS = "anlagenstatus";

  /**
   * Darstellungsmenu: Bereich fuer die Aktion "RDS/TMC" (Wert <code>"rds.tmc"</code>)
   * 
   */
  String RDS_TMC = "rds.tmc";

  // Konstanten fuer das Beeinflussung-Menu
  // ///////////////////////////////////////////

  /**
   * Name des Standard-Beeinflussung-Menus (Wert <code>"beeinflussung"</code>)
   */
  String MENU_BEEINFLUSSUNG = "beeinflussung";

  /**
   * Beeinflussung-Menu: Bereich fuer die Aktion "RDS-Meldungseingabe" (Wert <code>"rds_meldungseingabe"</code>)
   */
  String RDS_MELDUNGSEINGABE = "rds_meldungseingabe";

  /**
   * Beeinflussung-Menu: Bereich fuer die Aktion "Baustellen- und Unfalleingabe" (Wert
   * <code>"baustellen_unfalleingabe"</code>)
   */
  String BAUSTELLEN_UNFALLEINGABE = "baustellen_unfalleingabe";

  /**
   * Beeinflussung-Menu: Bereich fuer die Aktion "Sonderprogramme" (Wert <code>"sonderprogramme"</code>)
   */
  String SONDERPROGRAMME = "sonderprogramme";

  /**
   * Beeinflussung-Menu: Bereich fuer die Aktion "Manuelle Schaltungen" (Wert <code>"manuelle_schaltungen"</code>)
   */
  String MANUELLE_SCHALTUNGEN = "manuelle_schaltungen";

  /**
   * Beeinflussung-Menu: Bereich fuer die Aktion "Betriebsart" (Wert <code>"betriebsart"</code>)
   */
  String BETRIEBSART = "betriebsart";

  // Konstanten fuer das Standardmenu "Simulation"
  // //////////////////////////////////////////////////

  /**
   * Name des Standard-Simulation-Menus (Wert <code>"simulation"</code>)
   */
  String MENU_SIMULATION = "simulation";

  // Konstanten fuer das Standardmenu "Betrieb"
  // //////////////////////////////////////////////////

  /**
   * Name des Standard-Betrieb-Menus (Wert <code>"betrieb"</code>)
   */
  String MENU_BETRIEB = "betrieb";

  /**
   * Betrieb-Menu: Bereich fuer die Aktion "Betriebsmeldungen" (Wert <code>"betriebsmeldungen"</code>)
   */
  String BETRIEBSMELDUNGEN = "betriebsmeldungen";

  /**
   * Betrieb-Menu: Bereich fuer die Aktion "Wettermeldungen" (Wert <code>"wettermeldungen"</code>)
   */
  String WETTERMELDUNGEN = "wettermeldungen";

  /**
   * Betrieb-Menu: Bereich fuer die Aktion "Archivsystem" (Wert <code>"archivsystem"</code>)
   */
  String ARCHIVSYSTEM = "archivsystem";

  /**
   * Betrieb-Menu: Bereich fuer die Aktion "Lampentausch" (Wert <code>"lampentausch"</code>)
   */
  String LAMPENTAUSCH = "lampentausch";

  /**
   * Betrieb-Menu: Bereich fuer die Aktion "Fehlermeldungen" (Wert <code>"fehlermeldungen"</code>)
   */
  String FEHLERMELDUNGEN = "fehlermeldungen";

  // Konstanten fuer das Standardmenu "Parameter"
  // //////////////////////////////////////////////////

  /**
   * Name des Standard-Betrieb-Menus (Wert <code>"betrieb"</code>)
   */
  String MENU_PARAMETER = "parameter";

  // Konstanten fuer das Standardmenu "Protokolle"
  // //////////////////////////////////////////////////

  /**
   * Name des Standard-Betrieb-Menus (Wert <code>"betrieb"</code>)
   */
  String MENU_PROTOKOLLE = "protokolle";

  // Konstanten fuer das Standardmenu "System"
  // //////////////////////////////////////////////////

  /**
   * Name des Standard-System-Menus (Wert <code>"system"</code>)
   */
  String MENU_SYSTEM = "system";

  /**
   * Betrieb-Menu: Bereich fuer die Aktion "Benutzerverwaltung/Zugriffsrechte" (Wert <code>"benutzerverwaltung"</code>)
   */
  String BENUTZERVERWALTUNG = "benutzerverwaltung";

  /**
   * Betrieb-Menu: Bereich fuer die Aktion "Datenflussueberwachung" (Wert <code>"datenflussueberwachung"</code>)
   */
  String DATENFLUSSUEBERWACHUNG = "datenflussueberwachung";

  /**
   * Betrieb-Menu: Bereich fuer die Aktion "Optionen" (Wert <code>"optionen"</code>)
   */
  String OPTIONEN = "optionen";

  /**
   * Betrieb-Menu: Bereich fuer die Aktion "Ereigniskalender" (Wert <code>"ereigniskalender"</code>)
   */
  String EREIGNISKALENDER = "ereigniskalender";

  /**
   * Betrieb-Menu: Bereich fuer die Aktion "Systemkalender" (Wert <code>"systemkalender"</code>)
   */
  String SYSTEMKALENDER = "systemkalender";

  /**
   * Betrieb-Menu: Bereich fuer die Aktion "Zugang zum Verkehrsrechner" (Wert <code>"verkehrsrechner"</code>)
   */
  String VERKEHRSRECHNER = "verkehrsrechner";

  // Konstanten fuer das Standardmenu "Objekttypen"
  // //////////////////////////////////////////////////

  /**
   * Name des Standard-Objekttypen-Menus (Wert <code>"objekttypen"</code>)
   */
  String MENU_OBJEKTTYPEN = "objekttypen";

}
