/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.rw;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.core.runtime.preferences.DefaultScope;
import org.eclipse.core.runtime.preferences.IEclipsePreferences;


public class PreferenceInitializer extends AbstractPreferenceInitializer
{

	public static final String KOPFZEILE_LINKS = "kopfzeileLinks";

	public PreferenceInitializer()
	{
	}

	@Override
	public void initializeDefaultPreferences()
	{
		// Preferences preferences = Activator.getDefault().getPluginPreferences();
		// preferences.setDefault(KOPFZEILE_LINKS, "Default Kopfzeile");
		// preferences.setDefault("kopfzeileMitte", "Default Kopfzeile");
		// preferences.setDefault("kopfzeileRechts", "Default Kopfzeile");
		// preferences.setDefault("fusszeileLinks", "Default Kopfzeile");
		// preferences.setDefault("fusszeileMitte", "Default Kopfzeile");
		// preferences.setDefault("fusszeileRechts", "Default Kopfzeile");

		//Lesen erfolgt mittels InstanceScope!
		IEclipsePreferences defaultPref = new DefaultScope()
				.getNode(Activator.PLUGIN_ID);
		defaultPref.put(KOPFZEILE_LINKS, "Default Kopfzeile");
		defaultPref.put("kopfzeileMitte", "Default Kopfzeile");
		defaultPref.put("kopfzeileRechts", "Default Kopfzeile");
		defaultPref.put("fusszeileLinks", "Default Kopfzeile");
		defaultPref.put("fusszeileMitte", "Default Kopfzeile");
		defaultPref.put("fusszeileRechts", "Default Kopfzeile");

	}

}
