/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.rw.offlinekonfiguration;

/**
 * Mit Hilfe dieser Klasse lsst sich die Konfigurationsdatei bestimmen.
 * 
 * @author HofmannJ
 * 
 */
public class KonfigurationsDatei
{
  /**
   * Speichert die Singleton-Instanz dieser Klasse
   */
  private static KonfigurationsDatei _instanz = null;

  /**
   * Pfad zur Konfigurationsdatei
   */
  private String _pfadZuKonfigurationsDatei = null;

  /**
   * Liefert die Singleton-Instanz dieser Klasse.
   * 
   * @return Singleton-Instanz dieser Klasse
   */
  public static KonfigurationsDatei getInstanz()
  {
    if (_instanz == null)
    {
      _instanz = new KonfigurationsDatei();
    }
    return _instanz;
  }

  /**
   * Privater Konstruktor
   * 
   */
  private KonfigurationsDatei()
  {
  }

  /**
   * Liefert den Pfad zur Konfigurationsdatei.
   * 
   * @return Pfad zur Konfigurationsdatei
   */
  public String getPfadZurKonfigurationsDatei()
  {
    return _pfadZuKonfigurationsDatei;
  }

  /**
   * Setzt den Pfad zur Konfigurationsdatei.
   * 
   * @param dateiPfad
   *          Pfad zur Konfigurationsdatei
   */
  public void setPfadZurKonfigurationsDatei(String dateiPfad)
  {
    this._pfadZuKonfigurationsDatei = dateiPfad;
  }

}
