/*
 * Copyright 2007 by Kappich Systemberatung, Aachen
 * Copyright 2004 by Kappich+Kni Systemberatung Aachen (K2S)
 * 
 * This file is part of de.bsvrz.pat.sysbed.
 * 
 * de.bsvrz.pat.sysbed is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * de.bsvrz.pat.sysbed is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.pat.sysbed; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package de.bsvrz.pat.sysbed.dataview;

import javax.swing.*;
import javax.swing.border.LineBorder;
import java.awt.*;

/**
 * Diese Klasse reprsentiert die Zelle eines Blattes in der hierarchischen Struktur {@link RowData}.
 *
 * @author Kappich Systemberatung
 * @version $Revision: 5019 $
 */
public class RowElement extends JComponent {

	/* ########### Konstruktor ############# */
	/**
	 * Erstellt eine Zelle der {@link DataViewPanel OnlineTabelle}.
	 *
	 * @param text Inhalt der Zelle
	 */
	public RowElement(String text) {
		JLabel label = new JLabel();
		label.setText(text);
		label.setHorizontalAlignment(SwingConstants.CENTER);
		label.setVerticalAlignment(SwingConstants.NORTH);
		label.setBackground(new Color(0, 0, 0));

		setLayout(new BorderLayout());
		setBorder(new LineBorder(new Color(166, 166, 166)));
		add(label, BorderLayout.CENTER);
	}
}
