/*
 * This file is part of Rahmenwerk.
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 * 
 * Copyright (c) 2012 Swarco Traffic Systems GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * Swarco Traffic Systems GmbH - initial API and implementation
 * 
 * 
 * 
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae
 * D-76571 Gaggenau 
 * T. +49 (0)7225 / 64-03
 * F. +49 (0)7225 / 64-300 
 * E. office.sts@swarco.de
 */
package de.sts.esptool.dlgs;

/**
 * Diese Klase liefert die Rckgabe der Klasse {@link LadeSpeicherDialogMenu}. Damit lsst sich bestimmen, wo
 * gespeichert wird ({@link EnumSpeicherOrt}) und fr "wen" ({@link EnumSubjekt}) gespeichert wird.
 * 
 * @author HofmannJ
 * 
 */
public class SpeicherInfo
{

  /**
   * SpeicherOrt
   */
  private EnumSpeicherOrt _speicherOrt = null;

  /**
   * Subjekt
   */
  private EnumSubjekt _subjekt = null;

  /**
   * Konstruktor
   * 
   * @param speicherOrt
   *          {@link EnumSpeicherOrt} - Ort, wo zu Speichern ist
   * @param subjekt
   *          {@link EnumSubjekt} - Subjekt, fr das zu Speichern ist
   */
  public SpeicherInfo(EnumSpeicherOrt speicherOrt, EnumSubjekt subjekt)
  {
    this._speicherOrt = speicherOrt;
    this._subjekt = subjekt;
  }


  /**
   * Liefert den SpeicherOrt.
   * 
   * @return {@link EnumSpeicherOrt}
   */
  public EnumSpeicherOrt getSpeicherOrt()
  {
    return _speicherOrt;
  }

  /**
   * Liefert das Subjekt.
   * 
   * @return {@link EnumSubjekt}
   */
  public EnumSubjekt getSubjekt()
  {
    return _subjekt;
  }

  public String toString()
  {
    String re = "Speicher Ort: " + _speicherOrt.toString() + " Subjekt: "
        + _subjekt.toString();
    return re;
  }

}
